#include "StdAfx.h"
#include "ThreadEx.h"

CThreadEx::CThreadEx(void)
{
	m_hThread = NULL;
	m_dwThreadID = 0;
	m_hKillEvent = NULL;
}

CThreadEx::~CThreadEx(void)
{
}

BOOL CThreadEx::Start()
{
	//Ϊ
	if (NULL != m_hThread)
	{
		return TRUE;
	}

	//ر߳ź
	m_hKillEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
	assert(m_hKillEvent);

	//߳
	m_hThread = CreateThread(NULL, 0, ThreadProc, this, 0, &m_dwThreadID);
	assert(m_hThread);
	return (NULL != m_hThread);
}

//ִֹͣ
BOOL CThreadEx::Stop()
{
	//
	if (NULL == m_hThread)
	{
		return FALSE;
	}

	//̣߳ر¼Ȼȴ߳ɣ
	SignalObjectAndWait(m_hKillEvent, m_hThread, INFINITE, FALSE);
	
	//
	CloseHandle(m_hKillEvent);
	CloseHandle(m_hThread);
	m_hKillEvent = NULL;
	m_hThread = NULL;

	return TRUE;
}

//̹߳ٺ루߳ǰ˳FALSE򷵻TRUE
BOOL CThreadEx::Delay(DWORD dwMillisecond)
{
	return (WAIT_OBJECT_0 != WaitForSingleObject(m_hKillEvent, dwMillisecond));
}

//߳
DWORD WINAPI CThreadEx::ThreadProc(LPVOID lParam)
{
	CThreadEx *pThreadEx = static_cast<CThreadEx *>(lParam);

	//ֱ˳ź
	while (WAIT_OBJECT_0 != WaitForSingleObject(pThreadEx->m_hKillEvent, 1))
	{
		if (!pThreadEx->Run())
		{
			break;
		}
	}
	return 0;
}